// Pollyfill for app running on pre iOS 9 versions
if (!String.prototype.startsWith) {
    String.prototype.startsWith = function(searchString, position){
        position = position || 0;
        return this.substr(position, searchString.length) === searchString;
    };
}

var _usingAppStartupScript=true;
var _canUseSSL  = (_isStaging === 'false'  && _base.indexOf("mobileinventor.com") != -1) ? true : false;
var _baseDir    = _base; 
var _baseDirSSL = _baseDir.replace("http","https");
var _libraryPath = (_canUseSSL) ? _baseDirSSL +"applib/" : _baseDir +"applib/";
var _templatePath = (_canUseSSL) ? _baseDirSSL +"appdata/" : _baseDir +"appdata/";
var _systemVersion, _appVersion, _origSystemVersion, _origAppVersion, _isNewSystemVersion, _appHasChanges, _foundAppChanges, _versionCheckComplete=false, _versionCheckAsync, _windowLoaded;
var _cache;

function getVersionInfo(){
    _systemVersion  = localStorage.getItem("systemVersion");
    _appVersion     = localStorage.getItem('_appVersion' + _appId);
    
    if (!_systemVersion || _systemVersion == "0") _systemVersion=0;
    if (!_appVersion || _appVersion == "0") _appVersion=0;
    
    return (!_systemVersion || !_appVersion) ? false : true;
}
function getVersionInfoAjax(async){
    var dataStr = 'app_id=' + _appId + '&staging='+_isStaging; 
    $.ajax({
	type:"GET",
	async:async,
	url:_libraryPath + "getVersionInfo.php",
	data:dataStr,
	cache:false,
	crossDomain:true,
	success:function(data){
	    if (data){
            data = JSON.parse(data);
            _isNewSystemVersion = (data.sysver != _systemVersion); 
            _appHasChanges = (data.appver != _appVersion); 
            _origSystemVersion = _systemVersion;
            _origAppVersion    = _appVersion;
            _systemVersion = data.sysver;
            _appVersion    = data.appver;  
        
            if (_isNewSystemVersion || _appHasChanges) _foundAppChanges=true;
        
            //localStorage.setItem("systemVersion", _systemVersion);
            //localStorage.setItem('_appVersion' + _appId, _appVersion);
	    }
	    _versionCheckComplete=true;
	    if (async) $(window).trigger("versionCheckComplete");
	},
	error:function(e,c,d){}
    });
} 
function delayedVersionCheck(){
    // if pageloader not loaded then delay else if is app and not ready delay
    // We require pageloader as it has listener for any changes found via async check
    if ( (typeof _documentReady === "undefined" || !_documentReady)
    ||   (typeof _pageLoaded === "undefined" || !_pageLoaded)
    ||   (_isApp && (typeof _deviceReady === "undefined" || !_deviceReady)) )  {
	setTimeout(delayedVersionCheck, 800);
	return;
    }
	    
    getVersionInfoAjax(true); 
}

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
	window.addEventListener("load", this.onWindowLoaded, false);
    },
    onWindowLoaded: function(e) {
	_windowLoaded=true;
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        //console.log('Received Event: ' + id);
        
        if (id === "deviceready"){
            if (typeof device !== "undefined" && device.platform && device.platform.toLowerCase() === "android"){
                var vs = (device.version) ? device.version.substr(0,1) : null;
                var me = this;
                if (vs && vs >= 6 && cordova.plugins.permissions){
                    var permissions = cordova.plugins.permissions;
                    permissions.hasPermission(permissions.WRITE_EXTERNAL_STORAGE,function(status){
                        if(!status.hasPermission) {
                            navigator.notification.confirm(
                                "This app needs access to your device's storage to continue. We need this permission to store important system files that the app cannot operate without.", 	// message
                                function(button){
                                    if (button == 1){
                                        permissions.requestPermission(permissions.WRITE_EXTERNAL_STORAGE, 
                                            function(status){
                                                if (!status.hasPermission){
                                                    navigator.notification.alert("If you did not see a request for permission then please go to System->App Manager and change the app permissions there",
                                                        function () {
                                                            navigator.app.exitApp();
                                                        },"Permission Denied", "Exit App");
                                                }else {
                                                    me.versionChecks();                        
                                                }
                                            }, 
                                            function() {
                                                navigator.app.exitApp();
                                            });
                                    }else{
                                        navigator.app.exitApp();
                                    }
                                },      
                                'Storage Permission', 	// title
                                'Ok, Exit App'        	// buttonLabels					    
                            );
                        }else {
                            me.versionChecks();
                        }
                    },function(){
                        me.versionChecks();
                    });                        
                }else {
                    this.versionChecks();
                }
            }else {
                this.versionChecks();
            }
        }
    },
    versionChecks: function(){
        _versionCheckAsync = getVersionInfo();
        if (!_versionCheckAsync) {
            //sync call
            getVersionInfoAjax(false);  
            this.setupCache(true);
        }else {
            this.setupCache();
            delayedVersionCheck();
        }        
    },
    setupCache: function(resetCache){
        _cache = new CordovaFileCache({
             fs: new CordovaPromiseFS({ // An instance of CordovaPromiseFS is REQUIRED
                 Promise: Promise // <-- your favorite Promise lib (REQUIRED)
             }),
             mode: 'mirror', // or hash
             localRoot: 'data', 
             serverRoot: _base, 
             cacheBuster: true  
         });
        
        _cache.ready.then(function(list){
            if (resetCache) {
                console.log("clearing cache!");
                _cache.clear().then(
                    function(){
                        app.loadCache(_cache)
                    },
                    function(){
                        console.log("problem clearing cache!!");
                    });
            }else {
                app.loadCache(_cache);
            }
         });        
    },
    loadCache: function(cache){
        cache.add(_templatePath + 'css/style.css');
        cache.add(_templatePath + 'js/oneTime-min.js');
        cache.add(_templatePath + 'js/iscroll.js');
        cache.add(_templatePath + 'js/common.js');
        cache.add(_templatePath + 'js/pageLoader.js');
        cache.add(_templatePath + 'js/fancybox/jquery.fancybox.css');
        cache.add(_templatePath + 'js/fancybox/jquery.fancybox.pack.js');
	
        var onProgress = function(e){
            /*var progress ="Progress: " 
                + e.queueIndex // current download index 
                + " " 
                + e.queueSize; // total files to download
            console.log("Download Progress = "+progress); */            
        }
	// Note that we append _systemVersion to all of the file:// paths as iOS caches those paths even when we do a location.reload(true).
	// The new system version will cause it to actually go to filesystem to get file.
        cache.download(onProgress, false).then(
            // Download complete (if any)
            function(cache){
                var c,s;
                // Walk through css file and remove relative paths replacing them with absolute path.
                // If we find an absolute already then we have altered it before.  In that case, we
                // check cache and replace it with cached path if available.
                var fs = new CordovaPromiseFS({ Promise: Promise });
                var fn = cache.toPath(_templatePath + 'css/style.css');
                
                fs.read(fn).then(function(data){
                    var newData = data.replace(/url\(.*?\)/ig, function(match){
                        var path;
                        if (match.startsWith('url(\"./')){
                            path = _templatePath + "css/" + match.replace('url(\"./', '').replace('")', '');
                        }else if (match.startsWith('url(\"../')){
                            path = _templatePath + match.replace('url(\"../', '').replace('")', '');
                        }else if (match.startsWith('url("'+_templatePath)){
                            path = match.replace('url("', '').replace('")', '');
                        }else if (match.indexOf("file://") !== -1 || match.indexOf("cdvfile://") !== -1){
                            // actual path of cached files can change when app is restarted so we replace it.
                            path = match.replace('")', '').replace('\")', '');;
                            path = path.substr(path.lastIndexOf("/data/") + 6);
			    path += '?'+_systemVersion;
                        }
                        
                        if (path){
                            path = cache.get(path);
                            if (path.startsWith(_templatePath)) cache.add(path);
                            return 'url("'+path+'?'+_systemVersion+'")';                            
                        }else {
                            return match;
                        }
                    });
                    
                    if (cache.isDirty()) cache.download(function(){},false).then(function(cache){}, function(failedDownloads){});
                    
                    cache._fs.write(fn, newData).then(function(e){
                        c = document.createElement("link");
                        c.href=cache.get(_templatePath + 'css/style.css?')+'?'+_systemVersion;
                        c.rel="stylesheet";
                        c.type="text/css";
                        document.getElementsByTagName("head")[0].appendChild(c);

                        s = document.createElement( 'script' );
                        s.setAttribute( 'src', cache.get(_templatePath + 'js/pageLoader.js')+'?'+_systemVersion);
                        document.body.appendChild(s);                        
                    }, function(err){
                        console.log("could not write altered css file to filesystem - "+err);
                    });

                }, function(err){ console.log("error reading style.css - "+err); });
               
                s = document.createElement( 'script' );
                s.setAttribute( 'src', cache.get(_templatePath + 'js/oneTime-min.js')+'?'+_systemVersion);
                document.body.appendChild(s);
                      
                s = document.createElement( 'script' );
                s.setAttribute( 'src', cache.get(_templatePath + 'js/iscroll.js')+'?'+_systemVersion);
                document.body.appendChild(s);

                s = document.createElement( 'script' );
                s.setAttribute( 'src', cache.get(_templatePath + 'js/common.js')+'?'+_systemVersion);
                document.body.appendChild(s);

                c = document.createElement("link");
                c.href=cache.get(_templatePath + 'js/fancybox/jquery.fancybox.css')+'?'+_systemVersion;
                c.rel="stylesheet";
                c.type="text/css";
                document.getElementsByTagName("head")[0].appendChild(c);

                s = document.createElement( 'script' );
                s.setAttribute( 'src', cache.get(_templatePath + 'js/fancybox/jquery.fancybox.pack.js')+'?'+_systemVersion);
                document.body.appendChild(s);
            },function(failedDownloads) {
                console.log("download error!");
            }
        );
    }
};

$(document).ready(function() {
    app.initialize();
});